VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "English phonology search"
   ClientHeight    =   9480
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   11355
   Icon            =   "Search.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   9480
   ScaleWidth      =   11355
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkVowels 
      Caption         =   "Search vowels only"
      Height          =   375
      Left            =   600
      TabIndex        =   25
      Top             =   8160
      Width           =   2415
   End
   Begin VB.CheckBox chkSyllabified 
      Caption         =   "Search syllabified data"
      Height          =   375
      Left            =   600
      TabIndex        =   24
      Top             =   7680
      Width           =   2535
   End
   Begin VB.Frame Frame2 
      Height          =   1215
      Left            =   6240
      TabIndex        =   21
      Top             =   360
      Width           =   4455
      Begin VB.TextBox txtOrthography 
         Height          =   375
         Left            =   120
         TabIndex        =   23
         Top             =   720
         Width           =   4215
      End
      Begin VB.CommandButton cmdSearchOrthography 
         Caption         =   "Search orthography"
         Height          =   375
         Left            =   120
         TabIndex        =   22
         Top             =   240
         Width           =   4215
      End
   End
   Begin VB.TextBox txtInputFileName 
      Alignment       =   2  'Center
      Height          =   375
      Left            =   8160
      TabIndex        =   19
      Text            =   "in.txt"
      Top             =   7680
      Width           =   2295
   End
   Begin VB.CheckBox chkExclude 
      Caption         =   "Exclude compounds and productively affixed forms from the search"
      Height          =   375
      Left            =   600
      TabIndex        =   18
      Top             =   8640
      Width           =   5535
   End
   Begin VB.CheckBox chkIgnore5 
      Caption         =   "Check4"
      Height          =   195
      Left            =   9600
      TabIndex        =   17
      Top             =   2520
      Width           =   135
   End
   Begin VB.CheckBox chkIgnore4 
      Caption         =   "Check3"
      Height          =   195
      Left            =   7680
      TabIndex        =   16
      Top             =   2520
      Width           =   135
   End
   Begin VB.CheckBox chkIgnore3 
      Caption         =   "Check2"
      Height          =   195
      Left            =   5640
      TabIndex        =   15
      Top             =   2520
      Width           =   135
   End
   Begin VB.CheckBox chkIgnore2 
      Caption         =   "Check1"
      Height          =   195
      Left            =   3600
      TabIndex        =   14
      Top             =   2520
      Width           =   135
   End
   Begin VB.CheckBox chkIgnore1 
      Caption         =   "Check1"
      Height          =   195
      Left            =   1560
      TabIndex        =   12
      Top             =   2520
      Width           =   135
   End
   Begin VB.CommandButton cmdRereadClasses 
      Caption         =   "Reset button:  use these choices in current run"
      Height          =   255
      Left            =   3360
      TabIndex        =   11
      Top             =   8160
      Width           =   3855
   End
   Begin VB.TextBox txtExampleLength 
      Alignment       =   2  'Center
      Height          =   375
      Left            =   3360
      TabIndex        =   9
      Text            =   "100"
      Top             =   7440
      Width           =   615
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "Ex&it"
      Height          =   615
      Left            =   8160
      TabIndex        =   7
      Top             =   8520
      Width           =   2535
   End
   Begin VB.TextBox Text5 
      Alignment       =   2  'Center
      Height          =   615
      Left            =   8760
      TabIndex        =   5
      Top             =   1800
      Width           =   2000
   End
   Begin VB.TextBox Text4 
      Alignment       =   2  'Center
      Height          =   615
      Left            =   6720
      TabIndex        =   4
      Top             =   1800
      Width           =   2000
   End
   Begin VB.TextBox Text3 
      Alignment       =   2  'Center
      Height          =   615
      Left            =   4680
      TabIndex        =   3
      Top             =   1800
      Width           =   2000
   End
   Begin VB.TextBox Text2 
      Alignment       =   2  'Center
      Height          =   615
      Left            =   2640
      TabIndex        =   2
      Top             =   1800
      Width           =   2000
   End
   Begin VB.TextBox Text1 
      Alignment       =   2  'Center
      Height          =   615
      Left            =   600
      TabIndex        =   1
      Top             =   1800
      Width           =   2000
   End
   Begin VB.CommandButton cmdSearchTranscriptions 
      Caption         =   "Search transcriptions"
      Height          =   1215
      Left            =   600
      TabIndex        =   0
      Top             =   360
      Width           =   2175
   End
   Begin VB.Label Label4 
      Caption         =   "Use this input file:"
      Height          =   255
      Left            =   8160
      TabIndex        =   20
      Top             =   7440
      Width           =   2295
   End
   Begin VB.Line Line1 
      X1              =   600
      X2              =   10800
      Y1              =   3240
      Y2              =   3240
   End
   Begin VB.Label Label3 
      Caption         =   "Small check boxes:  ignore this item when sorting the output"
      Height          =   255
      Left            =   3720
      TabIndex        =   13
      Top             =   2880
      Width           =   4455
   End
   Begin VB.Label Label2 
      Caption         =   "Example lists in Medium output files should be no longer than this number (in characters)"
      Height          =   495
      Left            =   4080
      TabIndex        =   10
      Top             =   7440
      Width           =   3735
   End
   Begin VB.Label Label1 
      Caption         =   "Options"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   600
      TabIndex        =   8
      Top             =   6960
      Width           =   1935
   End
   Begin VB.Label lblListOfNaturalClasses 
      BackColor       =   &H00FFFFFF&
      Height          =   3255
      Left            =   600
      TabIndex        =   6
      Top             =   3480
      Width           =   10215
   End
   Begin VB.Menu mnuView 
      Caption         =   "View"
      Begin VB.Menu mnuViewResult 
         Caption         =   "View result of previous search"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "Help"
   End
   Begin VB.Menu mnuAbout 
      Caption         =   "About"
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Search.

'Look through a phonetic dictionary, provided, for strings of a type specified by the user.

Option Explicit

'Module level variables.

    'Variables for the words in the dictionary.
            Dim mNumberOfWords As Long
        'Phonetic transcription:
            'No syllabification.
                Dim mWords() As String
            'Coda consonants marked XCoda.
                Dim mWordsSyllabified() As String
        'Ditto, parsed into a two dimensional array with one segment per slot.
            Dim mWordsByPhoneme() As String
            Dim mWordsByPhonemeSyllabified() As String
            Dim mVowels() As String
        'CELEX lemma frequency:
            Dim mFrequencies() As Long
        'Same, divided among equivalent entries
            Dim mDividedFrequencies() As Long
        
        
        'Morphology, etc.
            Dim mAnnotation() As String
        'Other:
            Dim mOrthography() As String
            Dim mNumberOfPhonemesPerWord() As Long
            Dim mNumberOfVowelsPerWord() As Long
    
    'Phonological natural classes (user can freely add more):
        '2D array:
            Dim mNaturalClass() As String
        'The file name serves as the natural class name:
            Dim mNaturalClassName() As String
        'Others:
            Dim mNaturalClassSize() As Long
            Dim mNumberOfNaturalClasses As Long
            
    'Phoneme inventory:
        Dim mNumberOfPhonemes As Long
        Dim mPhonemeList() As String
        
    'Focus strings -- relevant for sorting the output when searching with natural classes.
        Dim mNumberOfFocusStrings As Long
        Dim mFocusStrings() As String
        Dim mFocusStringFrequencies() As Long
        Dim mFocusStringExamples() As String
        
    'Avoid redundant work in multiple runs:
        Dim mProgramHasRunAlready As Boolean
        
    'Avoid disappointing printout.
        Dim mNumberFound As Long
    'How much space to devote to examples.
        Dim mMaximumLengthOfExampleString As Long
        
    'Small output file with comma-separated word list (orthographic).
        Dim mOutputShortListNicelyFormatted As String
        
    'For running other programs
        Public mSpreadsheetLocation As String
        Public mWordProcessorLocation As String



Private Sub Form_Load()
    
    'Set up the interface.
    
    'Center the form on the screen.
        Let Me.Left = (Screen.Width - Me.Width) / 2
        Let Me.Top = (Screen.Height - Me.Height) / 2
        
        Call ReadSettings
        Call ReadPhonemeInventory
        Call PostTheUserLabel
    
End Sub

Sub PostTheUserLabel()

    'Post a big label that will facilitate the use of the program.
    
    'Segments with key words:
        Let lblListOfNaturalClasses = "AA1 cot, AA2 apricot, AE1 cat, AE2 contact, AH0 (schwa), AH1 but, AH2 mundane, AO1 awe, AO2 jackdaw, AW1 how, AW2 knowhow, AY1 eye " + _
            "AY2 Popeye, EH1 bet, EH2 inset, ER0 rubber, ER1 burr, ER2 insert, EY0 essay, EY1 day, EY2 essay, IH0 running, IH1 bit, IH2 heretic, IY0 happy, IY1 beet, IY2 athlete, OW0 motto, " + _
            "OW1 boat, OW2 anode, OY1 boy, OY2 purloin, UH1 book, UH2 Lilliput, UW0 gradual, UW1 boo, UW2 institute" + Chr(13) + Chr(13) + _
            "B bay, CH church, D day, DH the, F fit, G get, HH hat, JH joy, K cat, L lion, M mouse, N neon, NG sing, P pay, R ray, S say, SH shin, T tape, TH thin, V vow, W way, Y yes, Z zebra," + _
            "ZH vision"
    
    'Other guidance:
        Let lblListOfNaturalClasses = lblListOfNaturalClasses + Chr(13) + Chr(13) + "Word boundaries are [ and ]." + Chr(13) + Chr(13) + "You can make new natural classes by adding files in the "
        If chkSyllabified.Value = vbChecked Then
            Let lblListOfNaturalClasses = lblListOfNaturalClasses + "SyllabifiedNaturalClasses"
        Else
            Let lblListOfNaturalClasses = lblListOfNaturalClasses + "NaturalClasses"
        End If
    
    'Natural classes:
        Let lblListOfNaturalClasses = lblListOfNaturalClasses + " folder.  " + Chr(13) + Chr(13) + "The natural classes currently available are"
        'Add the natural classes
            If chkSyllabified.Value = vbChecked Then
                Call ReadSyllabifiedNaturalClassesShell
            Else
                Call ReadNaturalClassesShell
            End If
        
    'Make sure this label shows up right away.
        DoEvents

End Sub

Sub cmdSearchTranscriptions_Click()

    'Validate the inputs on the screen and get out rather than executing if they are not ok.
        If ValidateInput = False Then Exit Sub
    'Report progress.
        Let cmdSearchTranscriptions.Caption = "Preparing search ..."
    'Initialize items that accumulate during each search.
        Let mNumberFound = 0
        Let mNumberOfFocusStrings = 0
        Let mOutputShortListNicelyFormatted = ""
        ReDim mFocusStrings(0)
        ReDim mFocusStringFrequencies(0)
        ReDim mFocusStringExamples(0)
    Call SaveSettings
    Call OpenFiles
    Call DoOnceOnlyTasks
    'Search the appropriate list of transcriptions; chkSyllabified is true when the user selected the syllabified-search check box.
        If chkVowels.Value = vbChecked Then
            Call FindInTranscriptions(mVowels(), mNumberOfVowelsPerWord())
        ElseIf chkSyllabified.Value = vbChecked Then
            Call FindInTranscriptions(mWordsByPhonemeSyllabified(), mNumberOfPhonemesPerWord())
        Else
            Call FindInTranscriptions(mWordsByPhoneme(), mNumberOfPhonemesPerWord())
        End If
    Call FinishPreparingOutputFiles
    
    'xxxhithere
    
    'Report termination.
        If mNumberFound = 0 Then
            Let cmdSearchTranscriptions.Caption = "You can re-click here for another search."
        Else
            Let cmdSearchTranscriptions.Caption = "Done!  You can re-click here for another search."
        End If

End Sub

Sub cmdSearchOrthography_Click()
    
    'Report progress.
        Let cmdSearchOrthography.Caption = "Preparing search ..."
    Let mNumberFound = 0
    Call SaveSettings
    Call OpenFiles
    Call DoOnceOnlyTasks
    Call FindInOrthography
    Call FinishPreparingOutputFiles
    'Report termination.
        If mNumberFound = 0 Then
            Let cmdSearchOrthography.Caption = "You can re-click here for another search."
        Else
            Let cmdSearchOrthography.Caption = "Done!  You can re-click here for another search."
        End If
    
End Sub

Sub DoOnceOnlyTasks()
    If mProgramHasRunAlready = False Then
        Call ReadDictionary
        Call DivideWordsIntoPhonemes
        Let mProgramHasRunAlready = True
    End If
End Sub

Sub OpenFiles()

    On Error GoTo ErrorPoint
    
    'Open the output file.
        Open App.Path + "/FullOutput.txt" For Output As #2
        Open App.Path + "/ResultsOfSearchInInputFormat.txt" For Output As #3
        
    'Print a header for the output file.
        Print #2, "Word"; Chr(9); "Rev. spelling"; Chr(9); "Transcription"; Chr(9); "Search match"; Chr(9); "CELEX lemma freq."; Chr(9); "Annotation"
    
    Exit Sub
    
ErrorPoint:
    If Err.Number = 70 Then
        MsgBox "It looks like you have one of the output files already open in some other program. Please close this application, then click Ok to continue."
        Resume
    Else
        MsgBox "Error.  Description is " + Err.Description + ".  Please report to Bruce Hayes at bhayes@humnet.ucla.edu, specifying code number 73468."
    End If

End Sub

Sub ReadDictionary()

    'Go through the dictionary file line by line, extracting transcription, orthography, frequency, annotation.
    
    Dim MyLine As String
    
    'Open the dictionary in.txt and the output file out.txt.
        Open App.Path + "\" + txtInputFileName For Input As #1
        'Open App.Path + "\in.txt" For Input As #1
    
    'Initialize in case of reuse (e.g. with different choice of syllabification).
        Let mNumberOfWords = 0
        ReDim mWords(0)
        ReDim Preserve mWords(0)
        ReDim Preserve mWordsSyllabified(0)
        ReDim Preserve mVowels(0)
        ReDim Preserve mOrthography(0)
        ReDim Preserve mFrequencies(0)
        ReDim Preserve mDividedFrequencies(0)
        ReDim Preserve mAnnotation(0)
        
    Do While Not EOF(1)
        'Each word has all its information on one line.
            Line Input #1, MyLine
            Let MyLine = Trim(MyLine)
        'Redimensioning:
            Let mNumberOfWords = mNumberOfWords + 1
            ReDim Preserve mWords(mNumberOfWords)
            ReDim Preserve mWordsSyllabified(mNumberOfWords)
            ReDim Preserve mVowels(mNumberOfWords)
            ReDim Preserve mOrthography(mNumberOfWords)
            ReDim Preserve mFrequencies(mNumberOfWords)
            ReDim Preserve mDividedFrequencies(mNumberOfWords)
            ReDim Preserve mAnnotation(mNumberOfWords)
        'Digest orthography.
            Let mOrthography(mNumberOfWords) = s.Chomp(MyLine)
        'Move on one and digest transcription.
            Let MyLine = s.Residue(MyLine)
            Let mWords(mNumberOfWords) = "[ " + s.Chomp(MyLine) + " ]"
            
        'Move on one and digest syllabified transcription.
            Let MyLine = s.Residue(MyLine)
            Let mWordsSyllabified(mNumberOfWords) = "[ " + s.Chomp(MyLine) + " ]"
        'Move on and digest annotation (compounds, affixed forms, etc.)
            Let MyLine = s.Residue(MyLine)
            Let mAnnotation(mNumberOfWords) = s.Chomp(MyLine)
        'Move on and digest CELEX lemma frequency.
            Let MyLine = s.Residue(MyLine)
            Let mFrequencies(mNumberOfWords) = Val(s.Chomp(MyLine))
        'Same for divided frequencies.
            Let MyLine = s.Residue(MyLine)
            Let mDividedFrequencies(mNumberOfWords) = Val(s.Chomp(MyLine))
    Loop
    
    Close #1

End Sub

Sub DivideWordsIntoPhonemes()
    
    Dim MyWord As String, MyPhoneme As String
    Dim NumberOfVowelsFound As Long
    Dim WordIndex As Long, PositionIndex As Long, PhonemeIndex As Long
    
    'For speeded search, convert the space-separated transcriptions into arrays;
    '   first dimension is word; second dimension is phoneme order.
    
    'Redimension the needed arrays.
        ReDim mWordsByPhoneme(100, mNumberOfWords)
        ReDim mWordsByPhonemeSyllabified(100, mNumberOfWords)
        ReDim mVowels(100, mNumberOfWords)
        ReDim mNumberOfPhonemesPerWord(mNumberOfWords)
        ReDim mNumberOfVowelsPerWord(mNumberOfWords)
    
        For WordIndex = 1 To mNumberOfWords
            'Grab a word from the Focused database.
                If chkSyllabified.Value = vbChecked Then
                    Let MyWord = mWordsSyllabified(WordIndex)
                Else
                    Let MyWord = mWords(WordIndex)
                End If
            'Go through the word phoneme by phoneme.
                Let PositionIndex = 0
                Do
                    Let MyPhoneme = Trim(s.CustomChomp(MyWord, " "))
                    If MyPhoneme = "" Then
                        'Count the phonemes; the last incremented PositionIndex
                            Let mNumberOfPhonemesPerWord(WordIndex) = PositionIndex
                        'You're done with this word.
                            Exit Do
                    Else
                        'Augment the current position.
                            Let PositionIndex = PositionIndex + 1
                        'Install this phoneme.
                            If chkSyllabified.Value = vbChecked Then
                                Let mWordsByPhonemeSyllabified(PositionIndex, WordIndex) = MyPhoneme
                                'Also, vet the word for legal phonemes.  True is a parameter that means, "syllabified".
                                    Call VetWordForLegalPhonemes(MyPhoneme, MyWord, True)
                            Else
                                Let mWordsByPhoneme(PositionIndex, WordIndex) = MyPhoneme
                                    Call VetWordForLegalPhonemes(MyPhoneme, MyWord, False)
                            End If
                        'Prepare to continue with the next phoneme.
                            Let MyWord = s.CustomResidue(MyWord, " ")
                    End If
                Loop                'Go through the word.
        Next WordIndex              'Go through all words.

        'Deal with vowels.
            For WordIndex = 1 To mNumberOfWords
                Let NumberOfVowelsFound = 0
                'Go through the word phoneme by phoneme.
                    For PositionIndex = 1 To mNumberOfPhonemesPerWord(WordIndex)
                        If chkSyllabified.Value = vbChecked Then
                            Let MyPhoneme = mWordsByPhonemeSyllabified(PositionIndex, WordIndex)
                        Else
                            Let MyPhoneme = mWordsByPhoneme(PositionIndex, WordIndex)
                        End If
                        If IsInNaturalClass(MyPhoneme, "vowel") Or MyPhoneme = "[" Or MyPhoneme = "]" Then
                            'Augment the current position.
                                Let NumberOfVowelsFound = NumberOfVowelsFound + 1
                            'Install this phoneme.
                                Let mVowels(NumberOfVowelsFound, WordIndex) = MyPhoneme
                                Let mNumberOfVowelsPerWord(WordIndex) = NumberOfVowelsFound
                        End If
                    Next PositionIndex  'Go through the word.
            Next WordIndex              'Go through all words.


End Sub

Sub VetWordForLegalPhonemes(MyPhoneme As String, MyWord As String, UseSyllables As Boolean)
    
    Dim PhonemeIndex As Long
    
    'No syllabified sounds in unsyllabified searches.
        If UseSyllables = False Then
            If LCase(Right(MyPhoneme, 4)) = "coda" Then
                MsgBox "Caution:  the word " + MyWord + " contains the sound [" + MyPhoneme + "], but you're doing a simulation specified for nonsyllabified segments.  You may want to adjust your input files."
            End If
        End If
    'No unlisted phonemes.
        For PhonemeIndex = 1 To mNumberOfPhonemes
            If MyPhoneme = mPhonemeList(PhonemeIndex) Then
                Exit Sub
            End If
        Next PhonemeIndex
        MsgBox "Caution:  the word " + MyWord + " contains the sound [" + MyPhoneme + "], which is not on the list of phonemes AllSegments.txt.  You may want to adjust either in.txt or AllSegments.txt before continuing."

End Sub

Sub ReadNaturalClassesShell()

    'This uses the dir command to go through all the files in the relevant natural classes folder.
    '   When it runs out of files, it will experience an error and exit.
    
    'On Error GoTo ErrorPoint
    
    'Initialize in case program used more than once.
    Let mNumberOfNaturalClasses = 0
    
    Dim FileName As String
    
    'First class:
        Let FileName = Dir(App.Path + "/NaturalClasses/*.txt")
        Let FileName = Left(FileName, Len(FileName) - 4)
        Call ReadNaturalClasses(FileName, "unsyllabified")
    
    'Dir without arguments just cycles through the directory:
        Do
            Let FileName = Dir
            If FileName = "" Then Exit Sub
            Let FileName = Left(FileName, Len(FileName) - 4)
            Call ReadNaturalClasses(FileName, "unsyllabified")
        Loop
    
ErrorPoint:
    Exit Sub
    
End Sub


Sub ReadSyllabifiedNaturalClassesShell()
    
    On Error GoTo ErrorPoint
    
    Dim FileName As String
    
    Let mNumberOfNaturalClasses = 0
    
    'First class:
        Let FileName = Dir(App.Path + "\SyllabifiedNaturalClasses\*.txt")
        Let FileName = Left(FileName, Len(FileName) - 4)
        Call ReadNaturalClasses(FileName, "syllabified")
    
    'Dir without arguments just cycles through the directory:
        Do
            Let FileName = Dir
            Let FileName = Left(FileName, Len(FileName) - 4)
            Call ReadNaturalClasses(FileName, "syllabified")
        Loop
    
ErrorPoint:
    Exit Sub

End Sub


Sub ReadNaturalClasses(MyNaturalClassName, AmISyllabified As String)

    Dim MyLine As String, FileNum As Long
    
    Let mNumberOfNaturalClasses = mNumberOfNaturalClasses + 1
    
    ReDim Preserve mNaturalClass(100, mNumberOfNaturalClasses)
    ReDim Preserve mNaturalClassSize(mNumberOfNaturalClasses)
    ReDim Preserve mNaturalClassName(mNumberOfNaturalClasses)
    
    Let mNaturalClassName(mNumberOfNaturalClasses) = MyNaturalClassName
    Let lblListOfNaturalClasses = lblListOfNaturalClasses + ", " + MyNaturalClassName
    
    Let FileNum = FreeFile
    If chkSyllabified.Value = vbChecked Then
        Open App.Path + "/SyllabifiedNaturalClasses/" + mNaturalClassName(mNumberOfNaturalClasses) + ".txt" For Input As #FileNum
    Else
        Open App.Path + "/NaturalClasses/" + mNaturalClassName(mNumberOfNaturalClasses) + ".txt" For Input As #FileNum
    End If
    
    Do While Not EOF(FileNum)
        Line Input #FileNum, MyLine
        Let MyLine = Trim(MyLine)
        Let mNaturalClassSize(mNumberOfNaturalClasses) = mNaturalClassSize(mNumberOfNaturalClasses) + 1
        Let mNaturalClass(mNaturalClassSize(mNumberOfNaturalClasses), mNumberOfNaturalClasses) = Trim(MyLine)
    Loop
    Close #FileNum

End Sub


Sub FindInTranscriptions(MyTranscriptions() As String, MyLengths() As Long)

    Dim MyWord As String, SearchString As String
    Dim SearchStringLength As Long, FocusString As String
    Dim WordIndex As Long, PositionIndex As Long
    
    'Used for searching through words.
        Dim Phoneme1 As String, Phoneme2 As String, Phoneme3 As String, Phoneme4 As String, Phoneme5 As String
        
    'Avoid errors from spaces in boxes.
        Dim Box1 As String, Box2 As String, Box3 As String, Box4 As String, Box5 As String
        Let Box1 = Trim(Text1)
        Let Box2 = Trim(Text2)
        Let Box3 = Trim(Text3)
        Let Box4 = Trim(Text4)
        Let Box5 = Trim(Text5)
        
    Let SearchStringLength = SetSearchStringLength()
    
    For WordIndex = 1 To mNumberOfWords
        'Report progress
            If WordIndex / 100 = Int(WordIndex / 100) Then
                Let cmdSearchTranscriptions.Caption = "Searching the dictionary; completed " + Trim(Str(WordIndex)) + "/" + Trim(Str(mNumberOfWords))
                DoEvents
            End If
    
        Select Case SearchStringLength
            Case 1
                'Search one:
                For PositionIndex = 1 To MyLengths(WordIndex)
                    Let Phoneme1 = MyTranscriptions(PositionIndex, WordIndex)
                    If Satisfies(Phoneme1, Box1) Then
                        Let FocusString = Phoneme1
                        Call InstallANewEntry(WordIndex, FocusString, False)
                    End If
                Next PositionIndex
            
            Case 2
                'Search two:
                For PositionIndex = 1 To MyLengths(WordIndex) - 1
                    Let Phoneme1 = MyTranscriptions(PositionIndex, WordIndex)
                    If Satisfies(Phoneme1, Box1) Then
                        Let Phoneme2 = MyTranscriptions(PositionIndex + 1, WordIndex)
                        If Satisfies(Phoneme2, Box2) Then
                            'Form the focus string, omitting fields the user asked to omit.
                                    Let FocusString = ""
                                If chkIgnore1.Value = vbUnchecked Then
                                    Let FocusString = FocusString + Phoneme1 + Chr(9)
                                End If
                                If chkIgnore2.Value = vbUnchecked Then
                                    Let FocusString = FocusString + Phoneme2 + Chr(9)
                                End If
                                Let FocusString = Left(FocusString, Len(FocusString) - 1)
                            Call InstallANewEntry(WordIndex, FocusString, False)
                        End If
                    End If
                Next PositionIndex
            Case 3
                'Search three:
                For PositionIndex = 1 To MyLengths(WordIndex) - 2
                    Let Phoneme1 = MyTranscriptions(PositionIndex, WordIndex)
                    If Satisfies(Phoneme1, Box1) Then
                        Let Phoneme2 = MyTranscriptions(PositionIndex + 1, WordIndex)
                        If Satisfies(Phoneme2, Box2) Then
                            Let Phoneme3 = MyTranscriptions(PositionIndex + 2, WordIndex)
                            If Satisfies(Phoneme3, Box3) Then
                                'Form the focus string, omitting fields the user asked to omit.
                                    Let FocusString = ""
                                    If chkIgnore1.Value = vbUnchecked Then
                                        Let FocusString = FocusString + Phoneme1 + Chr(9)
                                    End If
                                    If chkIgnore2.Value = vbUnchecked Then
                                        Let FocusString = FocusString + Phoneme2 + Chr(9)
                                    End If
                                    If chkIgnore3.Value = vbUnchecked Then
                                        Let FocusString = FocusString + Phoneme3 + Chr(9)
                                    End If
                                    Let FocusString = Left(FocusString, Len(FocusString) - 1)
                                Call InstallANewEntry(WordIndex, FocusString, False)
                            End If
                        End If
                    End If
                Next PositionIndex
                
            Case 4
                'Search four:
                For PositionIndex = 1 To MyLengths(WordIndex) - 3
                    Let Phoneme1 = MyTranscriptions(PositionIndex, WordIndex)
                    If Satisfies(Phoneme1, Box1) Then
                        Let Phoneme2 = MyTranscriptions(PositionIndex + 1, WordIndex)
                        If Satisfies(Phoneme2, Box2) Then
                            Let Phoneme3 = MyTranscriptions(PositionIndex + 2, WordIndex)
                            If Satisfies(Phoneme3, Box3) Then
                                Let Phoneme4 = MyTranscriptions(PositionIndex + 3, WordIndex)
                                If Satisfies(Phoneme4, Box4) Then
                                    'Form the focus string, omitting fields the user asked to omit.
                                        Let FocusString = ""
                                        If chkIgnore1.Value = vbUnchecked Then
                                            Let FocusString = FocusString + Phoneme1 + Chr(9)
                                        End If
                                        If chkIgnore2.Value = vbUnchecked Then
                                            Let FocusString = FocusString + Phoneme2 + Chr(9)
                                        End If
                                        If chkIgnore3.Value = vbUnchecked Then
                                            Let FocusString = FocusString + Phoneme3 + Chr(9)
                                        End If
                                        If chkIgnore4.Value = vbUnchecked Then
                                            Let FocusString = FocusString + Phoneme4 + Chr(9)
                                        End If
                                        Let FocusString = Left(FocusString, Len(FocusString) - 1)
                                    Call InstallANewEntry(WordIndex, FocusString, False)
                                End If
                            End If
                        End If
                    End If
                Next PositionIndex
            Case 5
                'Search five:
                For PositionIndex = 1 To MyLengths(WordIndex) - 4
                    Let Phoneme1 = MyTranscriptions(PositionIndex, WordIndex)
                    If Satisfies(Phoneme1, Box1) Then
                        Let Phoneme2 = MyTranscriptions(PositionIndex + 1, WordIndex)
                        If Satisfies(Phoneme2, Box2) Then
                            Let Phoneme3 = MyTranscriptions(PositionIndex + 2, WordIndex)
                            If Satisfies(Phoneme3, Box3) Then
                                Let Phoneme4 = MyTranscriptions(PositionIndex + 3, WordIndex)
                                If Satisfies(Phoneme4, Box4) Then
                                    Let Phoneme5 = MyTranscriptions(PositionIndex + 4, WordIndex)
                                    If Satisfies(Phoneme5, Box5) Then
                                        'Form the focus string, omitting fields the user asked to omit.
                                            Let FocusString = ""
                                            If chkIgnore1.Value = vbUnchecked Then
                                                Let FocusString = FocusString + Phoneme1 + Chr(9)
                                            End If
                                            If chkIgnore2.Value = vbUnchecked Then
                                                Let FocusString = FocusString + Phoneme2 + Chr(9)
                                            End If
                                            If chkIgnore3.Value = vbUnchecked Then
                                                Let FocusString = FocusString + Phoneme3 + Chr(9)
                                            End If
                                            If chkIgnore4.Value = vbUnchecked Then
                                                Let FocusString = FocusString + Phoneme4 + Chr(9)
                                            End If
                                            If chkIgnore5.Value = vbUnchecked Then
                                                Let FocusString = FocusString + Phoneme5 + Chr(9)
                                            End If
                                        Call InstallANewEntry(WordIndex, FocusString, False)
                                    End If
                                End If
                            End If
                        End If
                    End If
                Next PositionIndex
        End Select
    Next WordIndex
    
End Sub

Sub FindInOrthography()

    Dim MyWord As String
    Dim WordIndex As Long, PositionIndex As Long
    Dim SearchString As String
    Dim StringLength As Long
    
    Let SearchString = Trim(txtOrthography.Text)
    Let StringLength = Len(SearchString)
    
    For WordIndex = 1 To mNumberOfWords
        'Report progress
            If WordIndex / 100 = Int(WordIndex / 100) Then
                Let cmdSearchOrthography.Caption = "Searching the dictionary; completed " + Trim(Str(WordIndex)) + "/" + Trim(Str(mNumberOfWords))
                DoEvents
            End If

        Let MyWord = "[" + mOrthography(WordIndex) + "]"
        For PositionIndex = 1 To Len(MyWord) - StringLength + 1
            If Mid(MyWord, PositionIndex, StringLength) = SearchString Then
                Call InstallANewEntry(WordIndex, SearchString, False)
            End If
        Next PositionIndex
    Next WordIndex
    
End Sub

Function SetSearchStringLength() As Long
    If Trim(Text1) <> "" Then
        Let SetSearchStringLength = 1
        If Trim(Text2) <> "" Then
            Let SetSearchStringLength = 2
            If Trim(Text3) <> "" Then
                Let SetSearchStringLength = 3
                If Trim(Text4) <> "" Then
                    Let SetSearchStringLength = 4
                    If Trim(Text5) <> "" Then
                        Let SetSearchStringLength = 5
                    End If
                End If
            End If
        End If
    End If
End Function

Sub InstallANewEntry(MyWordIndex As Long, MyFocusString As String, Syllabified As Boolean)
    
    Dim MyWord As String
    
    'If the user wants you to ignore commented forms, and this form is commented,
    '   then exit.
        If chkExclude.Value = vbChecked And Trim(mAnnotation(MyWordIndex)) <> "" Then
            Exit Sub
        End If
    
    'Augment number found.
        Let mNumberFound = mNumberFound + 1
    
    'This is the largest output file, FullOutput.txt.
        'The spelling.
            Print #2, mOrthography(MyWordIndex);
            'Add this to the small file that just lists the words.
                Let mOutputShortListNicelyFormatted = mOutputShortListNicelyFormatted + ", " + mOrthography(MyWordIndex)
        'The string-reversed spelling
            Print #2, Chr(9); Reversed(mOrthography(MyWordIndex));
        'The phonemic transcription, selected according to whether or not the user is searching syllabified entries.
            If Syllabified Then
                Let MyWord = mWordsSyllabified(MyWordIndex)
            Else
                MyWord = mWords(MyWordIndex)
            End If
            'Leave off the [ ]
                Print #2, Chr(9); Mid(MyWord, 3, Len(MyWord) - 4);
        'The segments matched by the formula the user entered.
            Print #2, Chr(9); MyFocusString;
            
        'Print #2, Chr(9); Reversed(mWords(MyWordIndex));
        Print #2, Chr(9); Trim(Str(mFrequencies(MyWordIndex)));
        Print #2, Chr(9); mAnnotation(MyWordIndex)
        
    'Also, print to the subset file, in input format, in case the user wants to do a double filtration.
        Print #3, mOrthography(MyWordIndex);
        Print #3, Chr(9); Mid(mWords(MyWordIndex), 3, Len(mWords(MyWordIndex)) - 4);
        Print #3, Chr(9); Mid(mWordsSyllabified(MyWordIndex), 3, Len(mWordsSyllabified(MyWordIndex)) - 4);
        Print #3, Chr(9); mAnnotation(MyWordIndex);
        Print #3, Chr(9); mFrequencies(MyWordIndex);
        Print #3, Chr(9); mDividedFrequencies(MyWordIndex)
    
    'In preparation for producing the medium-size output file, collate the results by focus string.
        Call DealWithFocusStrings(MyFocusString, MyWordIndex)
    
End Sub

Sub DealWithFocusStrings(MyFocusString As String, MyWordIndex As Long)

    'Typize, count, and exemplify focus strings.
    
    Dim i As Long
    
    For i = 1 To mNumberOfFocusStrings
        If MyFocusString = mFocusStrings(i) Then
            'Augment frequencies.
                Let mFocusStringFrequencies(i) = mFocusStringFrequencies(i) + 1
            'Augment examples, cutting off at mMaximumLengthOfExampleString characters with an indicator "...".
                If Right(mFocusStringExamples(i), 3) <> "..." Then
                    If Len(mFocusStringExamples(i)) > mMaximumLengthOfExampleString Then
                        Let mFocusStringExamples(i) = mFocusStringExamples(i) + " ..."
                    Else
                        Let mFocusStringExamples(i) = mFocusStringExamples(i) + " " + mOrthography(MyWordIndex)
                    End If
                End If
            'Do nothing more.
                GoTo ExitPoint
        End If
    Next i
        'If you got this far, it is novel.
            Let mNumberOfFocusStrings = mNumberOfFocusStrings + 1
            ReDim Preserve mFocusStrings(mNumberOfFocusStrings)
            ReDim Preserve mFocusStringFrequencies(mNumberOfFocusStrings)
            ReDim Preserve mFocusStringExamples(mNumberOfFocusStrings)
            Let mFocusStrings(mNumberOfFocusStrings) = MyFocusString
            Let mFocusStringFrequencies(mNumberOfFocusStrings) = 1
            Let mFocusStringExamples(mNumberOfFocusStrings) = mOrthography(MyWordIndex)
ExitPoint:
    
End Sub




Function Reversed(MyWord As String) As String
    Dim i As Long
    For i = Len(MyWord) To 1 Step -1
        Let Reversed = Reversed + Mid(MyWord, i, 1)
    Next i
    'xxx need reversed phonemes too.
End Function

Function IsInNaturalClass(MySegment As String, MyNaturalClass As String) As Boolean
    Dim NaturalClassIndex As Long, SegmentIndex As Long
    For NaturalClassIndex = 1 To mNumberOfNaturalClasses
        'Find the natural class in question.
            If LCase(mNaturalClassName(NaturalClassIndex)) = LCase(MyNaturalClass) Then
                'See if the segment is in it.
                    For SegmentIndex = 1 To mNaturalClassSize(NaturalClassIndex)
                        If LCase(mNaturalClass(SegmentIndex, NaturalClassIndex)) = LCase(MySegment) Then
                            Let IsInNaturalClass = True
                            Exit Function
                        End If
                    Next SegmentIndex
                    Let IsInNaturalClass = False
                    Exit Function
            End If
    Next NaturalClassIndex
End Function

Function Satisfies(MyPhoneme As String, MyDescription As String) As Boolean
    If LCase(MyPhoneme) = LCase(MyDescription) Then
        Let Satisfies = True
        Exit Function
    ElseIf IsInNaturalClass(MyPhoneme, MyDescription) Then
        Let Satisfies = True
        Exit Function
    End If
End Function

Sub FinishPreparingOutputFiles()

    On Error GoTo ErrorPoint
    
    Dim i As Long
    
    'Print search settings in main output file.
        Print #2, "zzz Search string was:  " + SearchStringDisplay()

    'Close the main output file, and also the input for purposes of multiple runs.
        Close #1
        Close #2
        Close #3
        
    'Punt if no examples were found.
        If mNumberFound = 0 Then
            MsgBox "No examples were found."
        Else
            'The small output file, with just the words in orthography.
                Open App.Path + "/SmallOutput.txt" For Output As #2
                Let mOutputShortListNicelyFormatted = Mid(mOutputShortListNicelyFormatted, 3)
                Print #2, SearchStringDisplay()
                Print #2, mOutputShortListNicelyFormatted
                Close #2
            'The medium length file, sorted by focus strings.
                Open App.Path + "/MediumOutput.txt" For Output As #2
                Print #2, "Search string was:  " + SearchStringDisplay()
                Print #2, "Focus string"; Chr(9); "Number in corpus"; Chr(9); "Examples"
                For i = 1 To mNumberOfFocusStrings
                    Print #2, mFocusStrings(i);
                    Print #2, Chr(9); Trim(Str(mFocusStringFrequencies(i)));
                    Print #2, Chr(9); mFocusStringExamples(i)
                Next i
                Close #2
                
            'Load a form giving the user options for displaying output.
                Load frmDisplayOptions
                frmDisplayOptions.Show
                Let Me.Visible = False
            
        End If
        Exit Sub
        
ErrorPoint:
    If Err.Number = 70 Then
        MsgBox "It looks like you have one of the output files already open in some other program. Please close this application, then click Ok to continue."
        Resume
    Else
        MsgBox "Error.  Description is " + Err.Description + ".  Please report to Bruce Hayes at bhayes@humnet.ucla.edu, specifying code number 73468."
    End If
    Exit Sub
End Sub

Function SearchStringDisplay() As String
    'Concatenate the boxes
        Let SearchStringDisplay = Trim(Text1 + " " + Text2 + " " + Text3 + " " + Text4 + " " + Text5)
End Function

Sub ReadSettings()

    Dim MyLine As String
    
    'Fill the boxes on the interface.
        Open App.Path + "/UserSettings.txt" For Input As #1
        Do While Not EOF(1)
            Line Input #1, MyLine
            Select Case MyLine
                
                Case "Input file name:"
                    Line Input #1, MyLine
                    Let txtInputFileName.Text = Trim(MyLine)
                Case "Box 1"
                    Line Input #1, MyLine
                    Let Text1 = Trim(MyLine)
                Case "Box 2"
                    Line Input #1, MyLine
                    Let Text2 = Trim(MyLine)
                Case "Box 3"
                    Line Input #1, MyLine
                    Let Text3 = Trim(MyLine)
                Case "Box 4"
                    Line Input #1, MyLine
                    Let Text4 = Trim(MyLine)
                Case "Box 5"
                    Line Input #1, MyLine
                    Let Text5 = Trim(MyLine)
                Case "Ignore Box 1 in sorting"
                    Line Input #1, MyLine
                    Select Case Trim(MyLine)
                        Case "yes"
                            Let chkIgnore1.Value = vbChecked
                        Case Else
                            Let chkIgnore1.Value = vbUnchecked
                    End Select
                Case "Ignore Box 2 in sorting"
                    Line Input #1, MyLine
                    Select Case Trim(MyLine)
                        Case "yes"
                            Let chkIgnore2.Value = vbChecked
                        Case Else
                            Let chkIgnore2.Value = vbUnchecked
                    End Select
                Case "Ignore Box 3 in sorting"
                    Line Input #1, MyLine
                    Select Case Trim(MyLine)
                        Case "yes"
                            Let chkIgnore3.Value = vbChecked
                        Case Else
                            Let chkIgnore3.Value = vbUnchecked
                    End Select
                Case "Ignore Box 4 in sorting"
                    Line Input #1, MyLine
                    Select Case Trim(MyLine)
                        Case "yes"
                            Let chkIgnore4.Value = vbChecked
                        Case Else
                            Let chkIgnore4.Value = vbUnchecked
                    End Select
                Case "Ignore Box 5 in sorting"
                    Line Input #1, MyLine
                    Select Case Trim(MyLine)
                        Case "yes"
                            Let chkIgnore5.Value = vbChecked
                        Case Else
                            Let chkIgnore5.Value = vbUnchecked
                    End Select
                Case "Orthography search box"
                    Line Input #1, MyLine
                    Let txtOrthography = Trim(MyLine)
                Case "Search syllabified data"
                    Line Input #1, MyLine
                    Select Case LCase(MyLine)
                        Case "yes"
                            Let chkSyllabified.Value = vbChecked
                        Case "no"
                            Let chkSyllabified.Value = vbUnchecked
                    End Select
                Case "Location (full path) of your spreadsheet program:"
                    Line Input #1, MyLine
                    Let mSpreadsheetLocation = Trim(MyLine)
                Case "Location (full path) of your word processor or text editor:"
                    Line Input #1, MyLine
                    Let mWordProcessorLocation = Trim(MyLine)
                Case "Exclude from counts all forms marked with annotations in the dictionary"
                    Line Input #1, MyLine
                    Select Case Trim(MyLine)
                        Case "yes"
                            Let chkExclude.Value = vbChecked
                        Case Else
                            Let chkExclude.Value = vbUnchecked
                    End Select
                Case "Example lists in Medium output files should be no longer than this number (in characters)"
                    Line Input #1, MyLine
                    Let mMaximumLengthOfExampleString = Val(Trim(MyLine))
                    Let txtExampleLength.Text = mMaximumLengthOfExampleString
                Case "Search vowels only"
                    Line Input #1, MyLine
                    Select Case (MyLine)
                        Case "yes"
                            Let chkVowels.Value = vbChecked
                        Case Else
                            Let chkVowels.Value = vbUnchecked
                    End Select
            End Select
        Loop
        Close #1
End Sub

Public Sub SaveSettings()
    Open App.Path + "/UserSettings.txt" For Output As #2
    Print #2, "Input file name:"
    Print #2, Trim(txtInputFileName.Text)
    Print #2, "Box 1"
    Print #2, Text1
    Print #2, "Box 2"
    Print #2, Text2
    Print #2, "Box 3"
    Print #2, Text3
    Print #2, "Box 4"
    Print #2, Text4
    Print #2, "Box 5"
    Print #2, Text5
    Print #2, "Ignore Box 1 in sorting"
    Select Case chkIgnore1.Value
        Case vbChecked
            Print #2, "yes"
        Case vbUnchecked
            Print #2, "no"
    End Select
    Print #2, "Ignore Box 2 in sorting"
    Select Case chkIgnore2.Value
        Case vbChecked
            Print #2, "yes"
        Case vbUnchecked
            Print #2, "no"
    End Select
    Print #2, "Ignore Box 3 in sorting"
    Select Case chkIgnore3.Value
        Case vbChecked
            Print #2, "yes"
        Case vbUnchecked
            Print #2, "no"
    End Select
    Print #2, "Ignore Box 4 in sorting"
    Select Case chkIgnore4.Value
        Case vbChecked
            Print #2, "yes"
        Case vbUnchecked
            Print #2, "no"
    End Select
    Print #2, "Ignore Box 5 in sorting"
    Select Case chkIgnore5.Value
        Case vbChecked
            Print #2, "yes"
        Case vbUnchecked
            Print #2, "no"
    End Select

    Print #2, "Orthography search box"
    Print #2, txtOrthography
    Print #2, "Search syllabified data"
    If chkSyllabified.Value = vbChecked Then
        Print #2, "yes"
    Else
        Print #2, "no"
    End If
    Print #2, "Location (full path) of your spreadsheet program:"
    Print #2, Trim(mSpreadsheetLocation)
    Print #2, "Location (full path) of your word processor or text editor:"
    Print #2, Trim(mWordProcessorLocation)
    Print #2, "Exclude from counts all forms marked with annotations in the dictionary"
    If chkExclude.Value = vbChecked Then
        Print #2, "yes"
    Else
        Print #2, "no"
    End If
    Print #2, "Example lists in Medium output files should be no longer than this number (in characters)"
    Print #2, Trim(Str(mMaximumLengthOfExampleString))
    Print #2, "Search vowels only"
    If chkVowels.Value = vbChecked Then
        Print #2, "yes"
    Else
        Print #2, "no"
    End If

    Close #2
End Sub




Function ValidateInput() As Boolean

    Dim Box(5) As String, SomeBoxIsFilled As Boolean, TroubleFlag As Boolean, BoxIsOk As Boolean
    Dim BoxIndex As Long, PhonemeIndex As Long, NaturalClassIndex As Long, i As Long, j As Long
    
    'Silently remove leading and trailing blanks
        Let Text1 = Trim(Text1)
        Let Text2 = Trim(Text2)
        Let Text3 = Trim(Text3)
        Let Text4 = Trim(Text4)
        Let Text5 = Trim(Text5)
        
    'Put the content into a manipulable array
        Let Box(1) = Text1
        Let Box(2) = Text2
        Let Box(3) = Text3
        Let Box(4) = Text4
        Let Box(5) = Text5
        
    'Make sure at least one box is filled.
        For i = 1 To 5
            If Box(i) <> "" Then
                Let SomeBoxIsFilled = True
                Exit For
            End If
        Next i
        If SomeBoxIsFilled = False Then
            MsgBox "Please type segments or natural classes in row of five boxes."
            Let ValidateInput = False
            Exit Function
        End If
    
    'Make sure the boxes are left-aligned.  Correct this tacitly.
        Do
            Let TroubleFlag = False
            For i = 1 To 4
                If Box(i) = "" And Box(i + 1) <> "" Then
                    Let TroubleFlag = True
                    Let Box(i) = Box(i + 1)
                    Let Box(i + 1) = ""
                    Exit For
                End If
            Next i
            If TroubleFlag = False Then Exit Do
        Loop
            
        Let Text1 = Box(1)
        Let Text2 = Box(2)
        Let Text3 = Box(3)
        Let Text4 = Box(4)
        Let Text5 = Box(5)
        DoEvents
            
    'Make sure the boxes have acceptable values.
        For BoxIndex = 1 To 5
            Let BoxIsOk = False
            'Either you can be a blank...
                If Box(BoxIndex) = "" Then
                        Let BoxIsOk = True
                        GoTo ExitPoint
                End If
            'or you can be a good phoneme...
                For PhonemeIndex = 1 To mNumberOfPhonemes
                    If LCase(Box(BoxIndex)) = LCase(mPhonemeList(PhonemeIndex)) Then
                        Let BoxIsOk = True
                        GoTo ExitPoint
                    End If
                Next PhonemeIndex
            'or you can be a good natural class...
                For NaturalClassIndex = 1 To mNumberOfNaturalClasses
                    If LCase(Box(BoxIndex)) = LCase(mNaturalClassName(NaturalClassIndex)) Then
                        Let BoxIsOk = True
                        GoTo ExitPoint
                    End If
                Next NaturalClassIndex
            'If you've gotten this far, you have a problem.
                MsgBox "The item in Box # " + Trim(Str(BoxIndex)) + " is neither a legal phoneme nor a legal natural class name.  Please fix this and click on the search button again."
                Let ValidateInput = False
                Exit Function
ExitPoint:
            'All is well for this particular box.
        Next BoxIndex
                    
            'All is well, return True so the program will continue to execute.
                Let ValidateInput = True

End Function


Sub ReadPhonemeInventory()
    'The phoneme inventory has to be read up front because we need it to vet reader entries.
        Dim MyLine As String
        Open App.Path + "/AllSegments.txt" For Input As #1
        Do While Not EOF(1)
            Line Input #1, MyLine
            Let mNumberOfPhonemes = mNumberOfPhonemes + 1
            ReDim Preserve mPhonemeList(mNumberOfPhonemes)
            Let mPhonemeList(mNumberOfPhonemes) = Trim(MyLine)
        Loop
        Close #1
End Sub

Public Sub mnuHelp_Click()
    Load frmHelp
    frmHelp.Show
End Sub

Sub mnuAbout_click()
    Dim m As String
    Let m = "English Phonology Search was programmed by Bruce Hayes of the UCLA Linguistics Department in 2011 using Microsoft Visual Basic 6.  There is no Mac version.  Please contact Bruce Hayes (bhayes@humnet.ucla.edu) with bugs, queries, and dictionary corrections."
    MsgBox m
End Sub

Public Sub cmdExit_Click()
    Close
    Unload frmHelp
    Unload frmDisplayOptions
    Unload Me
End Sub

Private Sub cmdRereadClasses_Click()
    'Add the natural classes.  This will automatically happen when the user label is posted.
        Call PostTheUserLabel
    'Also reset the example length.
        Let mMaximumLengthOfExampleString = Val(Trim(txtExampleLength))
End Sub

Private Sub chkIgnore1_Click()
    DoEvents
End Sub
Private Sub chkIgnore2_Click()
    DoEvents
End Sub
Private Sub chkIgnore3_Click()
    DoEvents
End Sub
Private Sub chkIgnore4_Click()
    DoEvents
End Sub
Private Sub chkIgnore5_Click()
    DoEvents
End Sub

Private Sub mnuViewResult_Click()
    'Show the result of the previous run.
    Load frmDisplayOptions
    frmDisplayOptions.Show
    Let Me.Visible = False
End Sub
